#ifndef __FL_DFB_Window_H__
#define __FL_DFB_Window_H__

#include <directfb.h>

class FL_DFB_WindowManager;

class FL_DFB_Window {
    friend class FL_DFB_WindowManager;

public:
	FL_DFB_Window(int x, int y, int w, int h);
	virtual ~FL_DFB_Window();

    bool getSurface(IDirectFBSurface** ret_surface);

    bool setOpacity(unsigned char opacity);
    inline unsigned char getOpacity() { return mOpacity; }
    inline bool isShown() { return mOpacity != 0; }

    // position & size & zorder
    inline int x() { return mX; }
    inline int y() { return mY; }
    inline int w() { return mW; }
    inline int h() { return mH; }
    inline void position(int& x, int &y) { x = mX; y = mY; }
    inline bool move(int dx, int dy) { return moveTo(mX + dx, mY + dy); }
    bool moveTo(int x, int y);
    inline void size(int& w, int& h) { w = mW; h = mH; }
    bool resize(int w, int h);
    bool setBounds(int x, int y, int w, int h);

    bool raiseToTop();
    bool lowerToBottom();

    bool requestFocus();
    bool grabPointer();
    bool ungrabPointer();
    bool grabKeyboard();
    bool ungrabKeyboard();

    // scaling
    //bool resizeSurface(int w, int h);

    inline unsigned int getXID() { return mXID; }

private:
    FL_DFB_WindowManager* mWM;    
    int mX;
    int mY;
    int mW;
    int mH;
    unsigned char mOpacity;
    IDirectFBSurface* mSurface;
    unsigned int mXID;
};

#endif //__FL_DFB_Window_H__

